
/*
 * $Id: ChbModel.h,v 1.2 1999/04/15 20:36:03 rousskov Exp $
 *
 *
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#ifndef CACHABILITY_MODEL_H
#define CACHABILITY_MODEL_H

#include "Rnd.h"

// generates cachability status for new oids
// computes decision ratio (DR) to use based on desired
//   cachablitly and hit ratios
class ChbModel {
	public:
		ChbModel();

		void ratios(double aCR, double hr);
		double cr() const { return theCR; }
		double dr() const { return theDR; }

		bool cacheIt() { return theGen() < theDR; }

	protected:
		RndGen theGen;
		double theCR;  // desired cachablility ratio
		double theDR;  // decision ratio to achieve desired CR
};

#endif
